   00001                                ************************************************************************
   00002                                *MI03                      MANAGEMENT INFORMATION                      *
   00003                                *    DEVICE ID: HH-65A                 HID:       XX.XX-01             *
   00004                                *    FILENAME:  JF_.A61                LANGUAGE:  ASSEMBLY             *
   00005                                *    LOAD MODUL:                       SYSTEM:    JC                   *
   00006                                *    COMPILER:                         ASSEMBLER: ASM V2.1A            *
   00007                                *    TRNR CPU:                         CPU TYPE:  SEL 32/77            *
   00008                                *    ITRTN RATE:                       MODE:                           *
   00009                                *    LINK EDITR:                                                       *
   00010                                *                                                                      *
   00011                                ************************************************************************
   00012                                *PU02                             PURPOSE                              *
   00013                                *                                                                      *
   00014                                ************************************************************************
   00015                                *TI02                      TECHNICAL INFORMATION                       *
   00016                                *    *KEYWORD* ENTP JF.                                                *
   00017                                *                                                                      *
   00018                                ************************************************************************
   00019                                *PA02                        PROGRAM ATTRIBUTES                        *
   00020                                *    LOGICAL RECORDS:            352   GENERAL COMMENTS:             3 *
   00021                                *    FORTRAN LINES:                0   NON-FORTRAN LINES:          352 *
   00022                                *    EXECUTABLE FTN STMTS:         0   NON-EXEC FORTRAN STMTS:       0 *
   00023                                *                                                                      *
   00024                                ************************************************************************
   00025                                *SU01                         SUBPROGRAM USAGE                         *
   00026                                *      NAME       NAME       NAME         NAME       NAME       NAME   *
   00027                                *    JV.DELMF   PAIRDATA   PAIRDATX     SS.MCB     SS.MCW              *
   00028                                *                                                                      *
   00029                                ************************************************************************
   00030                                *CH02                          CHANGE HISTORY                          *
   00031                                *    REV   DATE        SOFTWARE ANALYST               EMPLOYER         *
   00032                                *                               DESCRIPTION OF CHANGE                  *
   00033                                *    01  18JUL95   JOHN RUCKSTUHL             NAWCTSD CODE 493         *
   00034                                *              INITIAL HEADER INSTALLATION                             *
   00035                                *                                                                      *
   00036                                ************************************************************************
   00038                                         PROGRAM   JF.
   00039                                *
   00040                                *        REV 1     10/23/84        ADDED POWER-FAIL RESET SWITCH LOGIC
   00041                                ************************************************************************
   00042                                *
   00043                                **  EXTERNAL DEFINITIONS -
   00044                                *
   00045                                         DEF       JF.
   00046                                *
   00047                                ************************************************************************
   00048                                *
   00049                                         EXT       PAIRDATA        TABLE OF PAGE AND PAIR PAGE NUMBERS
   00050                                         EXT       PAIRDATX        END OF PAIR TABLE
   00051                                         EXT       SS.MCW          MOVE CONSECUTIVES WORDS
   00052                                         EXT       SS.MCB          MOVE CONSECUTIBE BYTES
   00053                                         EXT       JV.DELMF        DELETE MALFUNCTION
   00054                                *
   00055                                         LIST      NOMAC
   00056   P00000                                ZG$                       GLOBAL COMMON EQUATES
   00057                                *
   00058   P00000                                M.REQS                    REGISTER EQUATES
   00059                                *
   00060                                DATAPOOL COMMON    FFREEZE         FREEZE FLAG
   00061                                DATAPOOL COMMON    FJFCROV         CRASH OVRD FLAG
   00062                                DATAPOOL COMMON    FJFSTORE        STORE CONDITIONS FLAG
   00063                                DATAPOOL COMMON    FJFRESET        RESET CONDITIONS FLAG
   00064                                DATAPOOL COMMON    FJFPFRST        POWER-FAIL RESET CONDITIONS FLAG
   00065                                *
   00066                                DATAPOOL COMMON    IGTOC1CI        CURRENT DISPLAYED ID - CRT 1
   00067                                DATAPOOL COMMON    IGTOC1RI        REQUESTED DISPLAY ID - CRT 1
   00068                                DATAPOOL COMMON    IGTOC1RS        REQUESTED DISPLAY SUBPAGE - CRT 1
   00069                                DATAPOOL COMMON    IGTOC1PI        PREVIOUS DISPLAY ID - CRT 1
   00070                                DATAPOOL COMMON    IGTOC1PS        PREVIOUS DISPLAY SUBPAGE - CRT 1
   00071                                DATAPOOL COMMON    IGTLSTCS        LAST CROSS COUNTRY MAP SCALE
   00072                                DATAPOOL COMMON    IGTLSTMS        LAST APPR MAP SCALE
   00073                                *
   00074                                DATAPOOL COMMON    BGTOC1SB        STATUS BITS - CRT 1
   00075                                *
   00076                                DATAPOOL COMMON    TJKLINE1        ASCII KEYPAD TABLE - CRT 1
   00077                                DATAPOOL COMMON    IJKCHAR1        NUMBER OF DISPLAYED CHARS - CRT 1
   00078                                DATAPOOL COMMON    FJKENT1         KEYPAD ENTER SELECTION - CRT 1
   00079                                DATAPOOL COMMON    IMFEDIT         MALF DESCR. DISPLAYED ON EDIT LINE
   00080                                DATAPOOL COMMON    IMFDESCR        MALFUNCTION DESCRIPTION  (10*5W)
   00081                                DATAPOOL COMMON    IMFINDEX        MALFUNCTION INDEX        (10H)
   00082                                DATAPOOL COMMON    IMFEDNUM        MALF BIT NUMBER OF MALF ON EDIT LINE
   00083                                *
   00084   P00000  00                   FPRINLAT DATAB     0               PRINT DISPLAY LATCH FLAG
   00085   P00001    00                 FLPLAT   DATAB     0               LAST PAGE LATCH FLAG
   00086   P00002      00               FMFLAT   DATAB     0               MALF OVRID LATCH FLAG
   00087   P00003        00             FCRLAT   DATAB     0               CRASH OVRD LATCH FLAG
   00088   P00004  00                   FSCLAT   DATAB     0               STORE CONDITIONS LATCH FLAG
   00089   P00005    00                 FRCLAT   DATAB     0               RESET CONDITIONS LATCH FLAG
   00090   P00006      00               FPAIRLAT DATAB     0               PAIR LATCH FLAG
   00091   P00007        00             FMRMVLAT DATAB     0               MALF REMOVE LATCH FLAG
   00092   P00008  00                   FSTORE   DATAB     0               TRUE IF STORE BEFORE RESET
   00093   P0000C                                BOUND     1W
   00094                                *
   00095                                ************************************************************************
   00097                                ************************************************************************
   00098                                *
   00099   P0000C                       JF.      EQU       $
   00100   P0000C  DC000260   P00260             STF       R0,JF.SAVE      SAVE CALLER'S REGS
   00101                                *
   00102   P00010  CB80FFFF                      LI        R7,-1
   00103                                *
   00104                                ** CHECK DI'S AND SET APPROPRIATE FLAGS
   00105                                *
   00106   P00014                       JF.30    EQU       $              * LAST PAGE *
   00107   P00014  A68FC002    7C002             TBM       05,ZG.DI+1H      TEST DI BIT
   00108   P00018  F0800089   P00088             BNS       JF.35           . BRANCH IF NOT SET
   00109                                *
   00110   P0001C  AF080001   P00001             LB        R6,FLPLAT       CHECK LATCH STATUS
   00111   P00020  F200008D   P0008C             BNZ       JF.50           . BRANCH IF ALREADY LATCHED
   00112                                *
   00113   P00024  AE800001   A00000             LH        R5,IGTOC1PI     SET R5 = PREVIOUS PAGE ID
   00114   P00028  92800001   A00000             CAMH      R5,IGTOC1CI     CHECK IF TOGGLING BETWEEN MAP SCALES
   00115   P0002C  F2000041   P00040             BNE       $+5W
   00116   P00030  D6800001   A00000             STH       R5,IGTOC1RI     . STORE AS REQUESTED PAGE ID
   00117   P00034  AE800001   A00000             LH        R5,IGTOC1PS     SET R5 = PREVIOUS SUBPAGE
   00118   P00038  D6800001   A00000             STH       R5,IGTOC1RS     . STORE AS REQUESTED SUBPAGE
   00119   P0003C  EC00007D   P0007C             BU        JF.33
   00120   P00040  D6800001   A00000             STH       R5,IGTOC1RI     . STORE AS REQUESTED PAGE ID
   00121   P00044  F8000001   A00000             ZMH       IGTOC1RS        SET REQUESTED SUBPAGE TO 0
   00122                                *
   00123   P00048  0E40                          ZR        R4              PREPARE FOR DIVIDE
   00124   P0004C  CA040064                      DVI       R4,100          R5 = 1ST DIGIT OF 3 DIGIT PAGE NUMBER
   00125   P00050  CA850005                      CI        R5,5            CHECK IF MAP PAGE (500 - 511)
   00126   P00054  F200007D   P0007C             BNE       JF.33           SKIP IF NOT
   00127   P00058  CA05000C                      CI        R4,12
   00128   P0005C  EE80007D   P0007C             BGE       JF.33
   00129                                *
   00130   P00060  CA050000                      CI        R4,0            R4 = SUBPAGE (00 - 11)
   00131   P00064  F2000075   P00074             BNE       $+4W            IF NOT CROSS COUNTRY, MUST BE APR MAP
   00132   P00068  AE880000   A00000             LB        R5,IGTLSTCS     SET R5 = LAST CROSS COUNTRY MAP SCALE
   00133   P0006C  D6800001   A00000             STH       R5,IGTOC1RS     . STORE AS REQUESTED SUBPAGE
   00134   P00070  EC00007D   P0007C             BU        JF.33
   00135   P00074  AE880000   A00000             LB        R5,IGTLSTMS     SET R5 = LAST APPR MAP SCALE
   00136   P00078  D6800001   A00000             STH       R5,IGTOC1RS     . STORE AS REQUESTED SUBPAGE
   00137                                *
   00138   P0007C  98080000   A00000    JF.33    SBM       00,BGTOC1SB     SET DISPLAY REQUEST BIT
   00139   P00080  D7880001   P00001             STB       R7,FLPLAT       SET LATCH FLAG
   00140   P00084  EC00008D   P0008C             BU        JF.50
   00141                                *
   00142   P00088                       JF.35    EQU       $
   00143   P00088  F8080001   P00001             ZMB       FLPLAT          CLEAR LATCH FLAG
   00144                                *
   00145                                ************************************************************************
   00147                                ************************************************************************
   00148                                *
   00149   P0008C                       JF.50    EQU       $              * PAIR *
   00150   P0008C  A60FC002    7C002             TBM       04,ZG.DI+1H     TEST DI BIT
   00151   P00090  F0800109   P00108             BNS       JF.58           . BRANCH IF DI NOT SET
   00152                                *
   00153   P00094  AF080006   P00006             LB        R6,FPAIRLAT     CHECK LATCH STATUS
   00154   P00098  F200010D   P0010C             BNZ       JF.60           . BRANCH IF ALREADY LATCHED
   00155                                *
   00156   P0009C  AF000001   A00000             LH        R6,IGTOC1CI     CURRENTLY DISPLAYED PAGE
   00157   P000A0  35000000   X00000             LA        R2,PAIRDATA     START ADDRESS OF PAIR DATA
   00158   P000A4                       JF.52    EQU       $
   00159   P000A4  93400001    00000             CAMH      R6,0H,X2        COMPARE PAGE WITH TABLE ENTRY
   00160   P000A8  EE0000BD   P000BC             BEQ       JF.55           . BRANCH IF FOUND
   00161   P000AC  22A3                          ABR       R2,29           BUMP INDEX BY 1 WORD
   00162   P000B0  91000000   X00000             CAMW      R2,PAIRDATX     TEST FOR END OF TABLE
   00163   P000B4  ED8000A5   P000A4             BLT       JF.52           . LOOP IF NOT DONE
   00164   P000B8  EC00010D   P0010C             BU        JF.60           BRANCH IF NOT FOUND
   00165                                *
   00166   P000BC                       JF.55    EQU       $
   00167   P000BC  AEC00003    00002             LH        R5,1H,X2        PAIR PAGE
   00168   P000C0  D6800001   A00000             STH       R5,IGTOC1RI     STORE AS REQUESTED PAGEE
   00169   P000C4  F8000001   A00000             ZMH       IGTOC1RS        SET REQUESTED SUBPAGE TO 0
   00170                                *
   00171   P000C8  0E40                          ZR        R4              PREPARE FOR DIVIDE
   00172   P000CC  CA040064                      DVI       R4,100          R5 = 1ST DIGIT OF 3 DIGIT PAGE NUMBER
   00173   P000D0  CA850005                      CI        R5,5            CHECK IF MAP PAGE (500 - 511)
   00174   P000D4  F20000FD   P000FC             BNE       JF.56           SKIP IF NOT
   00175   P000D8  CA05000C                      CI        R4,12
   00176   P000DC  EE8000FD   P000FC             BGE       JF.56
   00177                                *
   00178   P000E0  CA050000                      CI        R4,0            R4 = SUBPAGE (00 - 11)
   00179   P000E4  F20000F5   P000F4             BNE       $+4W            IF NOT CROSS COUNTRY, MUST BE APR MAP
   00180   P000E8  AE880000   A00000             LB        R5,IGTLSTCS     SET R5 = LAST CROSS COUNTRY MAP SCALE
   00181   P000EC  D6800001   A00000             STH       R5,IGTOC1RS     . STORE AS REQUESTED SUBPAGE
   00182   P000F0  EC0000FD   P000FC             BU        JF.56
   00183   P000F4  AE880000   A00000             LB        R5,IGTLSTMS     SET R5 = LAST APPR MAP SCALE
   00184   P000F8  D6800001   A00000             STH       R5,IGTOC1RS     . STORE AS REQUESTED SUBPAGE
   00185                                *
   00186   P000FC  98080000   A00000    JF.56    SBM       00,BGTOC1SB     SET DISPLAY REQUEST BIT
   00187   P00100  D7880006   P00006             STB       R7,FPAIRLAT     SET LATCH FLAG
   00188   P00104  EC00010D   P0010C             BU        JF.60
   00189                                *
   00190   P00108                       JF.58    EQU       $
   00191   P00108  F8080006   P00006             ZMB       FPAIRLAT        CLEAR LATCH FLAG
   00192                                *
   00193                                ************************************************************************
   00195                                ************************************************************************
   00196                                *
   00197   P0010C                       JF.60    EQU       $              * STORE CONDITIONS *
   00198   P0010C  A58FC000    7C000             TBM       03,ZG.DI         TEST DI BIT
   00199   P00110  F080012D   P0012C             BNS       JF.68           . BRANCH IF NOT SET
   00200                                *
   00201   P00114  AF080004   P00004             LB        R6,FSCLAT       LOAD LATCH FLAG
   00202   P00118  F2000131   P00130             BNZ       JF.70           . BRANCH IF ALREADY LATCHED
   00203                                *
   00204   P0011C  D7880004   P00004             STB       R7,FSCLAT       SET LATCH FLAG
   00205   P00120  D7880000   A00000             STB       R7,FJFSTORE     SET STORE FLAG
   00206   P00124  D7880008   P00008             STB       R7,FSTORE       SET LOCAL STORE FLAG
   00207   P00128  EC000131   P00130             BU        JF.70
   00208                                *
   00209   P0012C                       JF.68    EQU       $
   00210   P0012C  F8080004   P00004             ZMB       FSCLAT          CLEAR LATCH FLAG
   00211                                *
   00212                                ************************************************************************
   00214                                ************************************************************************
   00215                                *
   00216   P00130                       JF.70    EQU       $              * RESET CONDITIONS *
   00217   P00130  A78FC000    7C000             TBM       07,ZG.DI         TEST DI BIT
   00218   P00134  F0800165   P00164             BNS       JF.78           . BRANCH IF NOT SET
   00219                                *
   00220   P00138  AF080005   P00005             LB        R6,FRCLAT       LOAD LATCH FLAG
   00221   P0013C  F2000169   P00168             BNZ       JF.80           . BRANCH IF ALTEADY LATCHED
   00222                                *
   00223   P00140  AF080000   A00000             LB        R6,FFREEZE      CHECK IF IN FREEZE
   00224   P00144  EE000169   P00168             BZ        JF.80           . BRANCH IF NOT FREEZE
   00225                                *
   00226   P00148  D7880005   P00005             STB       R7,FRCLAT       SET LATCH FLAG
   00227   P0014C  AF080008   P00008             LB        R6,FSTORE       CHECK IF STORE CONDITIONS USED FIRST
   00228   P00150  EE00015D   P0015C             BZ        $+3W            IF NOT, SET POWER-FAIL RESET FLAG
   00229                                *
   00230   P00154  D7880000   A00000             STB       R7,FJFRESET     SET STORE FLAG
   00231   P00158  EC000169   P00168             BU        JF.80
   00232   P0015C  D7880000   A00000             STB       R7,FJFPFRST     SET POWER-FAIL RESET FLAG
   00233   P00160  EC000169   P00168             BU        JF.80
   00234                                *
   00235   P00164                       JF.78    EQU       $
   00236   P00164  F8080005   P00005             ZMB       FRCLAT          CLEAR LATCH FLAG
   00237                                *
   00238                                ************************************************************************
   00240                                ************************************************************************
   00241                                *
   00242   P00168                       JF.80    EQU       $             * CRASH OVERRIDE *
   00243   P00168  A58FC001    7C001             TBM       11,ZG.DI        TEST DI BIT
   00244   P0016C  F080018D   P0018C             BNS       JF.88           . BRANCH IF DI NOT SET
   00245                                *
   00246   P00170  AF080003   P00003             LB        R6,FCRLAT       CHECK LATCH STATUS
   00247   P00174  F2000191   P00190             BNZ       JF.90           . BRANCH IF ALREADY LATCHED
   00248                                *
   00249   P00178  AF080000   A00000             LB        R6,FJFCROV      LOAD CRASH OVRD FLAG
   00250   P0017C  2F63                          TRC       R6,R6           TOGGLE FLAG VALUE
   00251   P00180  D7080000   A00000             STB       R6,FJFCROV      RESTORE FLAG VALUE
   00252   P00184  D7880003   P00003             STB       R7,FCRLAT       SET LATCH FLAG
   00253   P00188  EC000191   P00190             BU        JF.90
   00254                                *
   00255   P0018C                       JF.88    EQU       $
   00256   P0018C  F8080003   P00003             ZMB       FCRLAT          CLEAR LATCH FLAG
   00257                                *
   00258                                ************************************************************************
   00260                                ************************************************************************
   00261                                *
   00262   P00190                       JF.90    EQU       $             * MALFUNCTION REMOVE *
   00263   P00190  A78FC001    7C001             TBM       15,ZG.DI        TEST DI BIT
   00264   P00194  F08001DD   P001DC             BNS       JF.98           . BRANCH IF DI NOT SET
   00265                                *
   00266   P00198  AF080007   P00007             LB        R6,FMRMVLAT     CHECK LATCH STATUS
   00267   P0019C  F20001E1   P001E0             BNZ       JF.100          . BRANCH IF ALREADY LATCHED
   00268                                *
   00269   P001A0  34800000   A00000             LA        R1,IMFDESCR     DESCRIPTION OF LAST ENTERED MALF
   00270   P001A4  35000000   A00000             LA        R2,IMFEDIT      TO BE DISPLAYED ON EDIT LINE
   00271   P001A8  CA000014                      LI        R4,5W           LENGTH OF DESCRIPTION IS 5W
   00272   P001AC  F8800001   X00000             BL        SS.MCW          MOVE DESCRIPTION TO EDIT LINE
   00273                                *
   00274   P001B0  AC880000   A00000             LB        R1,IMFEDIT      CHECK IF A MALF IS ON EDIT LINE
   00275   P001B4  C8850020                      CI        R1,X'20'        IF BLANKS, NO MALF TO DELETE
   00276   P001B8  F20001C5   P001C4             BNE       $+3W            BRANCH TO DELETE MALFUNCTION
   00277   P001BC  F8080000   A00000             ZMB       IMFEDIT         ZERO 1ST BYTE TO ALLOW KEPAD ENTRY
   00278   P001C0  EC0001D5   P001D4             BU        JF.95           SKIP MALFUNCTION DELETION
   00279                                *
   00280   P001C4  0D20                          ZR        R2              DELETE TOP ENTRY IN MALF STACKS
   00281   P001C8  AE800001   A00000             LH        R5,IMFINDEX     MALF BIT NUMBER OF LAST ENTERED MALF
   00282   P001CC  D6800001   A00000             STH       R5,IMFEDNUM     MALF BIT NUM OF MALF MOVED TO EDIT LN
   00283   P001D0  F8800001   X00000             BL        JV.DELMF        DELETE MALFUNCTION
   00284                                *
   00285   P001D4                       JF.95    EQU       $
   00286   P001D4  D7880007   P00007             STB       R7,FMRMVLAT     SET LATCH FLAG
   00287   P001D8  EC0001E1   P001E0             BU        JF.100
   00288                                *
   00289   P001DC                       JF.98    EQU       $
   00290   P001DC  F8080007   P00007             ZMB       FMRMVLAT        CLEAR LATCH FLAG
   00291                                *
   00292                                ************************************************************************
   00294                                ************************************************************************
   00295                                *
   00296   P001E0                       JF.100   EQU       $             * PRINT DISPLAY *
   00297   P001E0  A70FC002    7C002             TBM       06,ZG.DI+1H     TEST DI BIT
   00298   P001E4  F0800209   P00208             BNS       JF.105          . BRANCH IF DI NOT SET
   00299                                *
   00300   P001E8  AF080000   P00000             LB        R6,FPRINLAT     CHECK LATCH STATUS
   00301   P001EC  F2000215   P00214             BNZ       JF.200          . BRANCH IF ALREADY LATCHED
   00302                                *
   00303   P001F0  98880000   A00000             SBM       01,BGTOC1SB     SET HARDCOPY DUMP REQUEST FLAG
   00304   P001F4                                M.SUME    HCNAME          RESUME HC/
   00305   P001FC  CB80FFFF                      LI        R7,-1
   00306   P00200  D7880000   P00000             STB       R7,FPRINLAT     SET LATCH FLAG
   00307   P00204  EC000215   P00214             BU        JF.200
   00308                                *
   00309   P00208                       JF.105   EQU       $
   00310   P00208  A4880000   A00000             TBM       01,BGTOC1SB     CHECK HARDCOPY REQUEST FLAG
   00311   P0020C  EC800215   P00214             BS        JF.200          . BRANCH IF HARDCOPY IN PROGRESS
   00312   P00210  F8080000   P00000             ZMB       FPRINLAT        CLEAR LATCH FLAG
   00313                                *
   00314                                ************************************************************************
   00317                                ************************************************************************
   00318                                *
   00319   P00214                       JF.200   EQU       $
   00320   P00214  9C8FC062    7C062             ZBM       01,ZG.DO+1H     CLEAR DO BIT
   00321   P00218  AE080000   A00000             LB        R4,FJFCROV      CHECK CRASH OVRD FLAG
   00322   P0021C  EE000225   P00224             BZ        $+2W
   00323                                *
   00324   P00220  988FC062    7C062             SBM       01,ZG.DO+1H     SET DO BIT
   00325                                *
   00326   P00224  9E0FC062    7C062             ZBM       04,ZG.DO+1H     CLEAR DO BIT
   00327   P00228  AE080000   P00000             LB        R4,FPRINLAT     CHECK PRINT DISPLAY FLAG
   00328   P0022C  EE000235   P00234             BZ        $+2W
   00329                                *
   00330   P00230  9A0FC062    7C062             SBM       04,ZG.DO+1H     SET DO BIT
   00331                                *
   00332   P00234  9D0FC062    7C062             ZBM       02,ZG.DO+1H     CLEAR DO BIT
   00333   P00238  AE080000   A00000             LB        R4,FJFSTORE     CHECK STORE FLAG
   00334   P0023C  EE000245   P00244             BZ        $+2W
   00335                                *
   00336   P00240  990FC062    7C062             SBM       02,ZG.DO+1H     SET DO BIT
   00337                                *
   00338   P00244  9D8FC062    7C062             ZBM       03,ZG.DO+1H     CLEAR DO BIT
   00339   P00248  AE080000   A00000             LB        R4,FJFRESET     CHECK RESET FLAG
   00340   P0024C  EE000255   P00254             BZ        $+2W
   00341                                *
   00342   P00250  998FC062    7C062             SBM       03,ZG.DO+1H     SET DO BIT
   00343                                *
   00344                                *
   00345   P00254  CC000260   P00260             LF        R0,JF.SAVE      RESTORE CALLER'S REGS
   00346   P00258  2800                          TRSW      R0              RETURN TO CALLER
   00347                                *
   00348   P00260                       JF.SAVE  RES       1F              HOLDS CALLER'S REGS
   00349                                *
   00350                                ************************************************************************
   00351   P00280  48432F20             HCNAME   DATAD     C'HC/'          HARDCOPY TASK NAME
           P00284  20202020
   00352   P00288                                END
*  0000  ERRORS IN JF.
  
  A40000    BGTOC1SB  *00074   00138   00186   00303   00310
  P00003    FCRLAT    *00087   00246   00252   00256
  A40000    FFREEZE   *00060   00223
  A40000    FJFCROV   *00061   00249   00251   00321
  A40000    FJFPFRST  *00064   00232
  A40000    FJFRESET  *00063   00230   00339
  A40000    FJFSTORE  *00062   00205   00333
  P00001    FLPLAT    *00085   00110   00139   00143
  P00007    FMRMVLAT  *00091   00266   00286   00290
  P00006    FPAIRLAT  *00090   00153   00187   00191
  P00000    FPRINLAT  *00084   00300   00306   00312   00327
  P00005    FRCLAT    *00089   00220   00226   00236
  P00004    FSCLAT    *00088   00201   00204   00210
  P00008    FSTORE    *00092   00206   00227
  A40000    IGTLSTCS  *00071   00132   00180
  A40000    IGTLSTMS  *00072   00135   00183
  A40000    IGTOC1CI  *00066   00114   00156
  A40000    IGTOC1PI  *00069   00113
  A40000    IGTOC1PS  *00070   00117
  A40000    IGTOC1RI  *00067   00116   00120   00168
  A40000    IGTOC1RS  *00068   00118   00121   00133   00136   00169   00181   00184
  A40000    IMFDESCR  *00080   00269
  A40000    IMFEDIT   *00079   00270   00274   00277
  A40000    IMFEDNUM  *00082   00282
  A40000    IMFINDEX  *00081   00281
  P0000C    JF.       *00099   00045
  P001E0    JF.100    *00296   00267   00287
  P00208    JF.105    *00309   00298
  P00214    JF.200    *00319   00301   00307   00311
  P0007C    JF.33     *00138   00119   00126   00128   00134
  P00088    JF.35     *00142   00108
  P0008C    JF.50     *00149   00111   00140
  P000A4    JF.52     *00158   00163
  P000BC    JF.55     *00166   00160
  P000FC    JF.56     *00186   00174   00176   00182
  P00108    JF.58     *00190   00151
  P0010C    JF.60     *00197   00154   00164   00188
  P0012C    JF.68     *00209   00199
  P00130    JF.70     *00216   00202   00207
  P00164    JF.78     *00235   00218
  P00168    JF.80     *00242   00221   00224   00231   00233
  P0018C    JF.88     *00255   00244
  P00190    JF.90     *00262   00247   00253
  P001D4    JF.95     *00285   00278
  P001DC    JF.98     *00289   00264
  P00260    JF.SAVE   *00348   00100   00345
  X61CC0    JV.DELMF  *00053   00283
  X61BE0    PAIRDATA  *00049   00157
  X61C18    PAIRDATX  *00050   00162
   00000    R0        *00058   00100   00345   00346
   00001    R1        *00058   00269   00274   00275
   00002    R2        *00058   00157   00161   00162   00270   00280
   00004    R4        *00058   00123   00124   00127   00130   00171   00172   00175   00178   00271   00321
                       00327   00333   00339
   00005    R5        *00058   00113   00114   00116   00117   00118   00120   00125   00132   00133   00135
                       00136   00167   00168   00173   00180   00181   00183   00184   00281   00282
   00006    R6        *00058   00110   00153   00156   00159   00201   00220   00223   00227   00246   00249
                       00250   00250   00251   00266   00300
   00007    R7        *00058   00102   00139   00187   00204   00205   00206   00226   00230   00232   00252
                       00286   00305   00306
  X61C50    SS.MCW    *00051   00272
   00002    X2        *00058   00159   00167
   7C000    ZG.       *00056   00056
   7C96C    ZG.BDY    *00056   00056
   7C9AB    ZG.BDYX   *00056   00056
   7CA6C    ZG.BEPCB  *00056   00056
   7C9AC    ZG.BLANK  *00056   00056
   7CA2C    ZG.BLINK  *00056   00056
   7C000    ZG.DI     *00056   00056   00107   00150   00198   00217   00243   00263   00297
   7C140    ZG.DI15   *00056   00056
   7C17F    ZG.DI15X  *00056   00056
   7C0E0    ZG.DIPB   *00056   00056
   7C13F    ZG.DIPBX  *00056   00056
   7C380    ZG.DIVD   *00056   00056
   7C57F    ZG.DIVDX  *00056   00056
   7C05F    ZG.DIX    *00056   00056
   7C060    ZG.DO     *00056   00056   00320   00324   00326   00330   00332   00336   00338   00342
   7C180    ZG.DO15   *00056   00056
   7C37F    ZG.DO15X  *00056   00056
   7C0A0    ZG.DOAU   *00056   00056
   7C0DF    ZG.DOAUX  *00056   00056
   7C780    ZG.DORD   *00056   00056
   7C7FF    ZG.DORDX  *00056   00056
   7C580    ZG.DOVD   *00056   00056
   7C77F    ZG.DOVDX  *00056   00056
   7C09F    ZG.DOX    *00056   00056
   7C800    ZG.DS     *00056   00056
   7C81F    ZG.DSX    *00056   00056
   7C82C    ZG.ICF    *00056   00056   00056
   7C86B    ZG.ICFX   *00056   00056
   7C86C    ZG.MF     *00056   00056
   7C96B    ZG.MFX    *00056   00056
   7C820    ZG.SD     *00056   00056
   7C82B    ZG.SDX    *00056   00056
  B62800    M.REQS    *00058
